## geographiclib 0.4.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: geographiclib
 Title: Access to 'GeographicLib'
-Version: 0.4.0
+Version: 0.4.1
 Authors@R: c(
     person("Michael", "Sumner", , "mdsumner@gmail.com", role = c("cre", "aut")), 
     person("Charles", "Karney", role = c("cph", "aut"), comment="GeographicLib author and maintainer"),
@@ -24,10 +24,10 @@
 VignetteBuilder: knitr
 Language: en-US
 NeedsCompilation: yes
-Packaged: 2026-02-20 10:36:41 UTC; mdsumner
+Packaged: 2026-02-27 10:56:35 UTC; mdsumner
 Author: Michael Sumner [cre, aut],
   Charles Karney [cph, aut] (GeographicLib author and maintainer),
   Mark Borgerding [cph] (kissfft library (BSD-3-Clause))
 Maintainer: Michael Sumner <mdsumner@gmail.com>
 Repository: CRAN
-Date/Publication: 2026-02-25 10:10:17 UTC
+Date/Publication: 2026-02-27 11:50:14 UTC
