## geographiclib 1.8

=== debian/changelog ===
geographiclib (1.8-2) unstable; urgency=low

  * Fixed typo in changelog to make lintian happy.
  * Added missing dependency from libgeographic5 in -dev package.
    (closes: #624181)
  * Policy bumped to 3.9.2, no changes.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Tue, 26 Apr 2011 16:50:10 +0200

geographiclib (1.8-1) unstable; urgency=low

  * New upstream release. Now manpages are installed for tools.
  * Moved to git for maintainance, so changed Vcs-* fields.
  * Changed to source format 3.0 and dropped quilt build-dep.
  * Policy changed to 3.9.1 without changes.
  * Now using level 8 for debhelper.
  * API changes from 1 to 5, changed binary package names as result.
  * Removed README.source.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Thu, 24 Feb 2011 18:06:44 +0100

geographiclib (1.2-1) unstable; urgency=low

  * New upstream release with a couple of bugs fixed in the geodesic routines.
    Previous patches merged: longdouble and destdir.
  * Reduced short descriptions in debian/control file to make lintian happy.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 26 May 2010 17:54:42 +0200

geographiclib (1.1-2) unstable; urgency=low

  * Added longdouble patch: fixed problems with unsupported long double 
    on some archs.  Thanks Nobuhiro Iwamatsu.
    (closes: #573930)
  * Added doxygen as build-dep.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Tue, 06 Apr 2010 12:46:55 +0200

geographiclib (1.1-1) unstable; urgency=low

  * Initial release.
    (closes: #571788)
  * A couple of problems fixed by quilt patches. Should go upstream.
  * Introduced a support script to download geoid grids from SF.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 10 Mar 2010 15:36:44 +0100
