=== debian/control ===
Source: geographiclib
Section: science
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
Build-Depends: cdbs, debhelper (>= 8), autotools-dev, doxygen
Standards-Version: 3.9.1
Homepage: http://geographiclib.sf.net/
Vcs-Browser: http://git.debian.org/?p=pkg-grass/geographiclib.git
Vcs-Git: git://git.debian.org/git/pkg-grass/geographiclib.git

Package: geographiclib-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: proj-bin
Recommends: bzip2
Description: A C++ library to solve some geodesic problems -- tools
 GeographicLib is a small set of C++ classes for converting between                                                                                         
 geographic, UTM, UPS, MGRS, geocentric, and local cartesian coordinates,                                                                                     
 for geoid calculations, and for computing geodesic. It is a suitable                                                                                         
 replacement for the core functionality provided by NGA Geotrans.
 .
 This package contains some core tools based on the GeographicLib library.

Package: libgeographiclib5
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: geographiclib-tools
Description: A C++ library to solve some geodesic problems -- library
 GeographicLib is a small set of C++ classes for converting between                                                                                         
 geographic, UTM, UPS, MGRS, geocentric, and local cartesian coordinates,                                                                                     
 for geoid calculations, and for computing geodesic. It is a suitable                                                                                         
 replacement for the core functionality provided by NGA Geotrans.
 .
 This package contains the GeographicLib shared library used at run-time 
 by applications.

Package: libgeographiclib-dev
Architecture: any
Section: libdevel
Depends: libgeographiclib5 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: A C++ library to solve some geodesic problems -- development files
 GeographicLib is a small set of C++ classes for converting between                                                                                         
 geographic, UTM, UPS, MGRS, geocentric, and local cartesian coordinates,                                                                                     
 for geoid calculations, and for computing geodesic. It is a suitable                                                                                         
 replacement for the core functionality provided by NGA Geotrans.
 .
 This package contains the files used to develop applications that use the
 GeographicLib library.
