=== debian/changelog ===
geographiclib (1.21-1ubuntu1) trusty; urgency=medium

  * Use dh-autoreconf instead of autotools-dev to also fix FTBFS on ppc64el by
    getting new libtool macros (still updates config.{sub,guess}).

 -- Logan Rosen <logan@ubuntu.com>  Thu, 09 Jan 2014 00:25:19 -0500

geographiclib (1.21-1) unstable; urgency=low

  * New upstream release.
  * Added python package with dh_python2 support.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Thu, 24 May 2012 16:19:52 +0200

geographiclib (1.18-1) unstable; urgency=low

  * New upstream release.
  * Policy bumped to 3.9.3, no changes required.
  * SONAME bumped to 9.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Fri, 09 Mar 2012 20:29:27 +0100
