=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: geographiclib
 Section: science
 Priority: optional
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
-Build-Depends: cdbs, debhelper (>= 8), autotools-dev, doxygen
-Standards-Version: 3.9.1
+Build-Depends: cdbs, debhelper (>= 8), dh-autoreconf, doxygen, python-all
+Standards-Version: 3.9.3
 Homepage: http://geographiclib.sf.net/
 Vcs-Browser: http://git.debian.org/?p=pkg-grass/geographiclib.git
 Vcs-Git: git://git.debian.org/git/pkg-grass/geographiclib.git
@@ -22,7 +23,7 @@
  .
  This package contains some core tools based on the GeographicLib library.
 
-Package: libgeographiclib5
+Package: libgeographiclib9
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -39,7 +40,7 @@
 Package: libgeographiclib-dev
 Architecture: any
 Section: libdevel
-Depends: libgeographiclib5 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libgeographiclib9 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: A C++ library to solve some geodesic problems -- development files
  GeographicLib is a small set of C++ classes for converting between                                                                                         
  geographic, UTM, UPS, MGRS, geocentric, and local cartesian coordinates,                                                                                     
@@ -48,3 +49,13 @@
  .
  This package contains the files used to develop applications that use the
  GeographicLib library.
+
+Package: python-geographiclib
+Architecture: any
+Section: python
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
+Description: Python binding for GeographicLib
+ GeographicLib is a small set of C++ classes for converting between                                                                                         
+ geographic, UTM, UPS, MGRS, geocentric, and local cartesian coordinates,                                                                                     
+ for geoid calculations, and for computing geodesic. It is a suitable                                                                                         
+ replacement for the core functionality provided by NGA Geotrans.
