=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/autoreconf.mk

DEB_PYTHON_DISTUTILS_SRCDIR = python
DEB_PYTHON2_MODULE_PACKAGES = python-geographiclib
DEB_PYTHON_SETUP_CMD = setup.py

include /usr/share/cdbs/1/class/python-vars.mk
include /usr/share/cdbs/1/class/python-distutils.mk 

DEB_CONFIGURE_EXTRA_FLAGS=--datadir=/usr/share/geographiclib --prefix=/usr
